#ifndef MYSTGUTIL_H_
#define MYSTGUTIL_H_
#include "VioletVreath.h"
#include "jp/ggaf/lib/util/StgUtil.h"

#include "jp/ggaf/core/util/GgafStatus.h"

#ifdef UTIL
    #undef UTIL
#endif
#define UTIL VioletVreath::MyStgUtil

#define STATUS(X) (NEW GgafCore::GgafStatus(STAT_BANPEI+1, VioletVreath::MyStgUtil::reset##X##Status))

//Cxgp hashval l錾
HASHVAL(EVENT_GOD_WILL_DIE);
HASHVAL(EVENT_PREPARE_TRANSIT_STAGE);
HASHVAL(EVENT_PREPARE_NEXT_STAGE);
HASHVAL(EVENT_JUST_GAME_OVER);

HASHVAL(EVENT_MY_SHIP_WAS_DESTROYED_BEGIN);
HASHVAL(EVENT_MY_SHIP_WAS_DESTROYED_FINISH);
HASHVAL(EVENT_ALL_MY_SHIP_WAS_DESTROYED);

HASHVAL(EVENT_PREGAMETITLESCENE_FINISH);
HASHVAL(EVENT_GAMETITLESCENE_FINISH);
HASHVAL(EVENT_GAMEDEMOSCENE_FINISH);
HASHVAL(EVENT_GAMESTART);
HASHVAL(EVENT_GOTO_GAMETITLE);
HASHVAL(EVENT_GAMEMODE_DECIDE);
HASHVAL(EVENT_GAMEOVERSCENE_FINISH);
HASHVAL(EVENT_GO_TO_TITLE);
HASHVAL(EVENT_NAMEENTRYSCENE_FINISH);
HASHVAL(EVENT_MENU_NAMEENTRY_DONE);


namespace VioletVreath {


/**
 * {Aṽ[eBeB .
 * @version 1.00
 * @since 2010/01/06
 * @author Masatoshi Tsuge
 */
class MyStgUtil : public GgafLib::StgUtil {
public:
    enum EffectKind {
        EF_NOTHING,
        EF_ENTRY_SMALL001_F90,
        EF_ENTRY_SMALL001_F60,
        EF_ENTRY_SMALL001_F30,
        EF_ENTRY_SMALL001_STAY_F90,
        EF_ENTRY_SMALL001_STAY_F60,
        EF_ENTRY_SMALL001_STAY_F30,
        EF_ENTRY_SMALL001_LONG,
        EF_ENTRY_MIDDLE001,
        EF_ENTRY_LARGE001,
        EF_LEAVE_SMALL001_F60,
        EF_LEAVE_SMALL001_F30,
        EF_LEAVE_SMALL001_F90,
        EF_LEAVE_MIDDLE001,
        EF_LEAVE_LARGE001,
        EF_EXPLOSION001,
        EF_EXPLOSION001_STAY,
        EF_EXPLOSION002,
        EF_EXPLOSION003,
        EF_BONUS001,
        EF_EXPLO_AND_BONUS001,
        EF_TURBO,
        EF_DAMAGED001,
    };

    enum ItemKind {
        ITEM_NOTHING,
        ITEM_MP_SMALL,
        ITEM_MP_MIDDLE,
        ITEM_MP_LARGE,
    };

    enum ShotKind {
        SHOT_NOTHING,

        SHOT_SMALL001,
        SHOT_SMALL002,

        SHOT_RV_NOMAL001,
        SHOT_RV_NOMAL002,
        SHOT_RV_GOLDEN_ANG_WAY,
    };

    enum DepoKind {
        DEPO_NOTHING,
        DEPO_LASER001,
        DEPO_LASER002,
    };


    /**
     * @̗Dʐ𒲂ׂ
     * @param kind_my
     * @param kind_enemy
     * @return ȉ̕\QƁB
     * <table>
     * <tr><th>0菬              </th><th>0   </th><th>0傫         </th></tr>
     * <tr><td>attribute_my̕   </td><td>i</td><td>kind_my̕D   </td></tr>
     * <tr><td>attribute_enemy̕D</td><td>i</td><td>kind_enemy̕</td></tr>
     * </table>
     */
    static int judgeMyAdvantage(actorkind attribute_my, actorkind attribute_enemy);

    static int judgeEnemyAdvantage(actorkind kattribute_enemy, actorkind attribute_my);

    /**
     * j󎞂ɉZ郉N|CgSTAT_AddRankPoint_Reductionɂ茸 .
     * @param prm_pEnemy G
     */
    static void updateEnemyRankPoint(GgafCore::GgafMainActor* prm_pEnemy);

    /**
     * (@)̗̑͌vZ .
     * @param prm_pMy  (@)
     * @param prm_pOpp (@ȊO)
     * @return (@)̗̑
     */
    static int calcMyStamina(GgafCore::GgafMainActor* prm_pMy, GgafCore::GgafMainActor* prm_pOpp);

    /**
     * (G@)̗̑͌vZ .
     * ɁA̗͂0ɂȂꍇ́A肪@֘AȂ΁A
     * Q[XRAAQ[NA(G@)̏tH[[Vւ̔j󂳂܂ʒmA
     * ɍsĂ܂֗\bhɂȂI
     * @param prm_pMy  (G@)
     * @param prm_pOpp (G@ȊO)
     * @return (G@)̗̑
     */
    static int calcEnemyStamina(GgafCore::GgafMainActor* prm_pEnemy, GgafCore::GgafMainActor* prm_pOpp);

    /**
     * ΏۃAN^[ɕRGtFNgA擾łΔAԂ .
     * Xe[^X(getStatus()) STAT_ExplosionEffectKind ̒lɂĎނU蕪B
     * @param prm_pActor ΏۃAN^[
     * @return ΏۃAN^[̔GtFNgiς݁jB́A擾łȂꍇ nullptrB
     */
    static GgafDxCore::GgafDxDrawableActor* activateExplosionEffectOf(GgafDxCore::GgafDxGeometricActor* prm_pActor);

    /**
     * ΏۃAN^[ɕR_[WGtFNgA擾łΔAԂ .
     * Xe[^X(getStatus()) STAT_DamagedEffectKind ̒lɂĎނU蕪B
     * @param prm_pActor ΏۃAN^[
     * @return ΏۃAN^[̃_[WGtFNgiς݁jB́A擾łȂꍇ nullptrB
     * @return
     */
    static GgafDxCore::GgafDxDrawableActor* activateDamagedEffectOf(GgafDxCore::GgafDxGeometricActor* prm_pActor);

    /**
     * ʏVbg .
     * @param prm_pActor
     * @return
     */
    static GgafDxCore::GgafDxDrawableActor* activateAttackShotOf(GgafDxCore::GgafDxGeometricActor* prm_pActor);

    /**     */
    static GgafCore::GgafActorDepository* getDepositoryOf(GgafDxCore::GgafDxGeometricActor* prm_pActor);

    /**
     * łԂe .
     * @param prm_pActor
     * @return
     */
    static GgafDxCore::GgafDxDrawableActor* activateRevengeShotOf(GgafDxCore::GgafDxGeometricActor* prm_pActor);

    /**
     * ΏۃAN^[ɕRێACeA擾łΗLɂAԂ .
     * Xe[^X(getStatus()) STAT_ItemKind ̒lɂăACeނU蕪B
     * @param prm_pActor ΏۃAN^[
     * @return ΏۃAN^[̕ێACeiς݁jB́A擾łȂꍇ nullptrB
     */
    static GgafDxCore::GgafDxDrawableActor* activateItemOf(GgafDxCore::GgafDxGeometricActor* prm_pActor);

    /**
     * ΏۃAN^[ɕRŃGtFNgA擾łΗLɂAԂ .
     * ^C~OIɂ́AGtFNgƓł邱ƂB<BR>
     * j󎞂̕ϓXRA{[iX\Aʏ̔GtFNgȊO̓ȃGtFNgɎgpB<BR>
     * Xe[^X(getStatus()) STAT_DestroyedEffectKind ̒lɂĎނU蕪B
     * @param prm_pActor ΏۃAN^
     * @return ΏۃAN^[̏ŃGtFNgiς݁jB́A擾łȂꍇ nullptrB
     */
    static GgafDxCore::GgafDxDrawableActor* activateDestroyedEffectOf(GgafDxCore::GgafDxGeometricActor* prm_pActor);

    /**
     * ΏۃAN^[ɕRGtFNgA擾łΗLɂAԂ .
     * Xe[^X(getStatus()) STAT_EntryEffectKind ̒lɂĎނU蕪B
     * @param prm_pActor ΏۃAN^[
     * @return ΏۃAN^[̓GtFNgiς݁jB́A擾łȂꍇ nullptrB
     */
    static GgafDxCore::GgafDxDrawableActor* activateEntryEffectOf(GgafDxCore::GgafDxGeometricActor* prm_pActor);

    /**
     * ΏۃAN^[ɕRޏGtFNgA擾łΗLɂAԂ .
     * Xe[^X(getStatus()) STAT_LeaveEffectKind ̒lɂĎނU蕪B
     * @param prm_pActor ΏۃAN^[
     * @return ΏۃAN^[̑ޏGtFNgiς݁jB́A擾łȂꍇ nullptrB
     */
    static GgafDxCore::GgafDxDrawableActor* activateLeaveEffectOf(GgafDxCore::GgafDxGeometricActor* prm_pActor);

    /**
     * ΏۃAN^[̕RAtH[[VSŃGtFNgƃXRAZ .
     * Xe[^X(getStatus()) STAT_FormationDestroyedEffectKind ̒lɂĎނU蕪B
     * @param prm_pActor ΏۃAN^[
     * @return ΏۃAN^[̃tH[[VSŃGtFNgiς݁jB́A擾łȂꍇ nullptrB
     */
    static GgafDxCore::GgafDxDrawableActor* activateFormationDestroyedEffectOf(GgafDxCore::GgafDxGeometricActor* prm_pActor);
    /**
     * ΏۃAN^[̂ɕRtH[[VSŃACeA擾łΗLɂAԂ .
     * Xe[^X(getStatus()) STAT_FormationDestroyedItemKind ̒lɂăACeނU蕪B
     * @param prm_pActor ΏۃAN^[
     * @return ΏۃAN^[̃tH[[VSŃACeiς݁jB́A擾łȂꍇ nullptrB
     */
    static GgafDxCore::GgafDxDrawableActor* activateFormationDestroyedItemOf(GgafDxCore::GgafDxGeometricActor* prm_pActor);

    /**
     * ΏۃAN^[ɕRŗLGtFNgîPjA擾łΗLɂAԂ .
     * Xe[^X(getStatus()) STAT_ProperEffect01Kind ̒lɂĎނU蕪B
     * @param prm_pActor ΏۃAN^[
     * @return ΏۃAN^[̓GtFNgiς݁jB́A擾łȂꍇ nullptrB
     */
    static GgafDxCore::GgafDxDrawableActor* activateProperEffect01Of(GgafDxCore::GgafDxGeometricActor* prm_pActor);

    /**
     * GLqbg̕WIȏ .
     * j󂳂ꂽꍇ<br>
     * Ej󎞓_Z<br>
     * ENZ<br>
     * EACeo             activateItemOf()<br>
     * EŎGtFNgJn activateDestroyedEffectOf()<br>
     * EłԂeo           activateRevengeShotOf()<br>
     * EGtFNgo       activateExplosionEffectOf()<br>
     * EґSŔ<br>
     * EґSŎACeo(STAT_ItemKind)<br>
     * j󂳂Ȃꍇ<br>
     * E_[W^_Z<br>
     * E_[WtbV\       STAT_FlushAble<br>
     * E_[WGtFNgo activateDamagedEffectOf()<br>
     * @param prm_this qbggiGLj̃AN^[n
     * @param prm_pOther qbg̃AN^[n
     * @return true:j󂳂ꂽ/false:j󂳂ĂȂ
     */
    static bool transactEnemyHit(GgafDxCore::GgafDxDrawableActor* prm_this, GgafDxCore::GgafDxGeometricActor* prm_pOther);

    /**
     * ґSj󎞂̕WIȏ .
     * @param prm_pActor_last_destroyed ґ̍Ōɔj󂳂ꂽAN^[n
     * @return ґSŎGtFNg
     */
    static GgafDxCore::GgafDxDrawableActor* transactFormationDestroyAll(GgafDxCore::GgafDxDrawableActor* prm_pActor_last_destroyed);

    // ȉ gen01 start ` end Excel}Nɂ莩ꂽR[hłB
    // R[hύX́uXe[^XCreater.xlsvsƁB
    // gen01 start
	//@
	static GgafCore::GgafStatus* resetMyShipStatus(GgafCore::GgafStatus* p);
	//@Vbg
	static GgafCore::GgafStatus* resetMyShot001Status(GgafCore::GgafStatus* p);
	//}WbNGlM[j
	static GgafCore::GgafStatus* resetMyMagicEnergyCoreStatus(GgafCore::GgafStatus* p);
	//@[U[
	static GgafCore::GgafStatus* resetMyStraightLaserChip001Status(GgafCore::GgafStatus* p);
	//IvV
	static GgafCore::GgafStatus* resetMyOptionStatus(GgafCore::GgafStatus* p);
	//IvVVbg
	static GgafCore::GgafStatus* resetMyOptionShot001Status(GgafCore::GgafStatus* p);
	//IvVJ[u[U[
	static GgafCore::GgafStatus* resetMyOptionWateringLaserChip001Status(GgafCore::GgafStatus* p);
	//IvVXg[g[U[
	static GgafCore::GgafStatus* resetMyOptionStraightLaserChip001Status(GgafCore::GgafStatus* p);
	//gDs[h
	static GgafCore::GgafStatus* resetMyTorpedoStatus(GgafCore::GgafStatus* p);
	//gDs[h
	static GgafCore::GgafStatus* resetMyTorpedoBlastStatus(GgafCore::GgafStatus* p);
	//ėpVbg001
	static GgafCore::GgafStatus* resetShot001Status(GgafCore::GgafStatus* p);
	//ėpVbg002
	static GgafCore::GgafStatus* resetShot002Status(GgafCore::GgafStatus* p);
	//ėpVbg003~j[U[
	static GgafCore::GgafStatus* resetShot003Status(GgafCore::GgafStatus* p);
	//ėp~j[U[Vbg
	static GgafCore::GgafStatus* resetShot004Status(GgafCore::GgafStatus* p);
	//ėpGXg[g[U[001
	static GgafCore::GgafStatus* resetEnemyStraightLaserChip001Status(GgafCore::GgafStatus* p);
	//ėpGJ[u[U[001
	static GgafCore::GgafStatus* resetEnemyWateringLaserChip001Status(GgafCore::GgafStatus* p);
	//GX
	static GgafCore::GgafStatus* resetEnemyEresStatus(GgafCore::GgafStatus* p);
	//GXVbg001
	static GgafCore::GgafStatus* resetEnemyEresShot001Status(GgafCore::GgafStatus* p);
	//XgGA
	static GgafCore::GgafStatus* resetEnemyStraeaStatus(GgafCore::GgafStatus* p);
	//XgGA[U[
	static GgafCore::GgafStatus* resetEnemyStraeaLaserChip001Status(GgafCore::GgafStatus* p);
	//XgGA[U[
	static GgafCore::GgafStatus* resetEnemyStraeaLaserChip002Status(GgafCore::GgafStatus* p);
	//XgGA[U[
	static GgafCore::GgafStatus* resetEnemyStraeaLaserChip003Status(GgafCore::GgafStatus* p);
	//XgGA[U[
	static GgafCore::GgafStatus* resetEnemyStraeaLaserChip004Status(GgafCore::GgafStatus* p);
	//IXieBXBÃnb`j
	static GgafCore::GgafStatus* resetEnemyOmulusStatus(GgafCore::GgafStatus* p);
	//GXieBXBÃnb`j
	static GgafCore::GgafStatus* resetEnemyEmusStatus(GgafCore::GgafStatus* p);
	//GX̃[U[
	static GgafCore::GgafStatus* resetEnemyEmusLaserChip001Status(GgafCore::GgafStatus* p);
	//GeBX
	static GgafCore::GgafStatus* resetEnemyEtisStatus(GgafCore::GgafStatus* p);
	//X
	static GgafCore::GgafStatus* resetEnemyRisStatus(GgafCore::GgafStatus* p);
	//QA
	static GgafCore::GgafStatus* resetEnemyGeriaStatus(GgafCore::GgafStatus* p);
	//nA
	static GgafCore::GgafStatus* resetEnemyHaliaStatus(GgafCore::GgafStatus* p);
	//܂P
	static GgafCore::GgafStatus* resetEnemyTamago01Status(GgafCore::GgafStatus* p);
	//CP
	static GgafCore::GgafStatus* resetEnemyIrceStatus(GgafCore::GgafStatus* p);
	//eBXBAig[Xj
	static GgafCore::GgafStatus* resetEnemyRatislaviaStatus(GgafCore::GgafStatus* p);
	//n`{bNX001
	static GgafCore::GgafStatus* resetWall001Status(GgafCore::GgafStatus* p);
	//n`vY001
	static GgafCore::GgafStatus* resetWall001PrismStatus(GgafCore::GgafStatus* p);
	//AX
	static GgafCore::GgafStatus* resetEnemyAllasStatus(GgafCore::GgafStatus* p);
	//E[m~A
	static GgafCore::GgafStatus* resetEnemyUnomiaStatus(GgafCore::GgafStatus* p);
	//G~A
	static GgafCore::GgafStatus* resetEnemyEmiliaStatus(GgafCore::GgafStatus* p);
	//G~Af
	static GgafCore::GgafStatus* resetEnemyEmiliaFragmentStatus(GgafCore::GgafStatus* p);
	//G~AfЂ̒f
	static GgafCore::GgafStatus* resetEnemyEmiliaFragment2Status(GgafCore::GgafStatus* p);
	//G~AfЂ̒fЂ̒f
	static GgafCore::GgafStatus* resetEnemyEmiliaFragment3Status(GgafCore::GgafStatus* p);
	//MPACe
	static GgafCore::GgafStatus* resetMagicPointItem001Status(GgafCore::GgafStatus* p);
	//MPACe
	static GgafCore::GgafStatus* resetMagicPointItem002Status(GgafCore::GgafStatus* p);
	//MPACe
	static GgafCore::GgafStatus* resetMagicPointItem003Status(GgafCore::GgafStatus* p);
	//XRAACe
	static GgafCore::GgafStatus* resetScoreItem001Status(GgafCore::GgafStatus* p);
	//VreathACe
	static GgafCore::GgafStatus* resetVreathItem001Status(GgafCore::GgafStatus* p);
	//G[x
	static GgafCore::GgafStatus* resetEnemyEbeStatus(GgafCore::GgafStatus* p);
	//qYr[
	static GgafCore::GgafStatus* resetEnemyHisbeStatus(GgafCore::GgafStatus* p);
	//qYr[2
	static GgafCore::GgafStatus* resetEnemyHisbe002Status(GgafCore::GgafStatus* p);
	//qYr[[U[
	static GgafCore::GgafStatus* resetEnemyHisbeLaserChip001Status(GgafCore::GgafStatus* p);
	//qYr[[U[
	static GgafCore::GgafStatus* resetEnemyHisbeLaserChip002Status(GgafCore::GgafStatus* p);
	//qYr[[U[
	static GgafCore::GgafStatus* resetEnemyHisbeLaserChip003Status(GgafCore::GgafStatus* p);
	//hXeA
	static GgafCore::GgafStatus* resetEnemyDrasteaStatus(GgafCore::GgafStatus* p);
	//^e
	static GgafCore::GgafStatus* resetEnemyTalanteStatus(GgafCore::GgafStatus* p);
	//GXgGA
	static GgafCore::GgafStatus* resetEnemyEsperiaStatus(GgafCore::GgafStatus* p);
	//GXgGA[U[
	static GgafCore::GgafStatus* resetEnemyEsperiaLaserChip001Status(GgafCore::GgafStatus* p);
	//O[eXg
	static GgafCore::GgafStatus* resetTestGuStatus(GgafCore::GgafStatus* p);
	//`L[eXg
	static GgafCore::GgafStatus* resetTestChokiStatus(GgafCore::GgafStatus* p);
	//p[eXg
	static GgafCore::GgafStatus* resetTestPaStatus(GgafCore::GgafStatus* p);
	//m[}[eXg
	static GgafCore::GgafStatus* resetTestNomalStatus(GgafCore::GgafStatus* p);
	//O[Vbg
	static GgafCore::GgafStatus* resetTestGuShotStatus(GgafCore::GgafStatus* p);
	//`L[Vbg
	static GgafCore::GgafStatus* resetTestChokiShotStatus(GgafCore::GgafStatus* p);
	//p[Vbg
	static GgafCore::GgafStatus* resetTestPaShotStatus(GgafCore::GgafStatus* p);
	//m[}[Vbg
	static GgafCore::GgafStatus* resetTestNomalShotStatus(GgafCore::GgafStatus* p);
	//eBXBAAC
	static GgafCore::GgafStatus* resetEnemyRatislaviaEyeStatus(GgafCore::GgafStatus* p);
	//eBXBAACpXg[g[U[001
	static GgafCore::GgafStatus* resetEnemyRatislaviaEyeStraightLaserChip001Status(GgafCore::GgafStatus* p);
	//G~Il
	static GgafCore::GgafStatus* resetEnemyErmioneStatus(GgafCore::GgafStatus* p);
	//G~Ilr̓
	static GgafCore::GgafStatus* resetEnemyErmioneArmHeadStatus(GgafCore::GgafStatus* p);
	//G~Ilr̓
	static GgafCore::GgafStatus* resetEnemyErmioneArmBodyStatus(GgafCore::GgafStatus* p);
	//G~Ilr̎_
	static GgafCore::GgafStatus* resetEnemyErmioneArmWeakStatus(GgafCore::GgafStatus* p);
	//Ab|[
	static GgafCore::GgafStatus* resetEnemyApphoStatus(GgafCore::GgafStatus* p);
	//AeBIy
	static GgafCore::GgafStatus* resetEnemyAntiopeStatus(GgafCore::GgafStatus* p);
	//fwCh
	static GgafCore::GgafStatus* resetEnemyDelheidStatus(GgafCore::GgafStatus* p);
	//ATi
	static GgafCore::GgafStatus* resetEnemyAlisanaStatus(GgafCore::GgafStatus* p);
	//C[_
	static GgafCore::GgafStatus* resetEnemyIdaStatus(GgafCore::GgafStatus* p);
	//^SX
	static GgafCore::GgafStatus* resetEnemyThagorasStatus(GgafCore::GgafStatus* p);
	//IgDi
	static GgafCore::GgafStatus* resetEnemyOrtunaStatus(GgafCore::GgafStatus* p);
	//O
	static GgafCore::GgafStatus* resetEnemyGlajaStatus(GgafCore::GgafStatus* p);
	//Oe
	static GgafCore::GgafStatus* resetEnemyGlajaLance001Status(GgafCore::GgafStatus* p);
	//hD[i
	static GgafCore::GgafStatus* resetEnemyDunaStatus(GgafCore::GgafStatus* p);
	//I[c@eBA
	static GgafCore::GgafStatus* resetEnemyOzartiaStatus(GgafCore::GgafStatus* p);
	//I[c@eBAVbgOP(ǃubN)
	static GgafCore::GgafStatus* resetEnemyOzartiaShot01Status(GgafCore::GgafStatus* p);
	//I[c@eBA[U[`bv
	static GgafCore::GgafStatus* resetEnemyOzartiaLaserChip01Status(GgafCore::GgafStatus* p);
	//I[c@eBAX
	static GgafCore::GgafStatus* resetEnemyOzartiaPillar01Status(GgafCore::GgafStatus* p);
	//GrEX
	static GgafCore::GgafStatus* resetEnemyOebiusStatus(GgafCore::GgafStatus* p);
    // gen01 end
};

}
#endif /*MYSTGUTIL_H_*/
